
#include <stm32f10x.h>              /* STM32F10x Library */


#include "w6100.h"						/* W6100 Register definition */
#include "w6100_init.h"
#include "SPI.h"
#include "socket.h"
//#include "webpage.h"
#include "httpult.h"
#ifndef DATA_BUF_SIZE
	#define DATA_BUF_SIZE			2048
#endif
#define AS_IPV4 2
#define AS_IPV6 23
#define AS_IPDUAL 11
typedef  void (*pFunction)(void);
char* msg_v4 = "IPv4 mode";
char* msg_v6 = "IPv6 mode";
char* msg_dual = "Dual IP mode";
uint8_t buff[2048];
uint8 reboot_flag = 0;
CONFIG_MSG ConfigMsg;
/******************************************************************************/
/*******************           Main function             **********************/
/******************************************************************************/
int main(void)
{
  /*init system */							  
	Systick_Init(72);	
	/*init usart */
	USART1_Init(); 		
	printf("usart init ok\r\n");
	/*init gpio FSMC/SPI*/
	GPIO_Configuration();		
#if _WIZCHIP_IO_MODE_ & _WIZCHIP_IO_MODE_BUS_INDIR_
	
	 FSMC_Init();

#else	
	WIZ_SPI_Init();
	
#endif
	
	/*Reset W6100*/
	Reset_W6100();
	
	/*init w6100 network*/
	Set_Network();														


	while(1)																			
	{	
		 
		 do_http(AS_IPV4);
     if(reboot_flag) 
	   {     
				reboot();
				reboot_flag =0;			
		 }
	}
	
}

void reboot(void)
{
	#if 0
  pFunction Jump_To_Application;
  uint32 JumpAddress;
  JumpAddress = *(vu32*) (0x00000004);
//	JumpAddress= main;
  Jump_To_Application = (pFunction) JumpAddress;
  Jump_To_Application();
	#endif
		Reset_W6100();
	  Set_Network();
}
